﻿using System.IO;
using NUnit.Framework;

namespace Vts.MonteCarlo.PostProcessor.Test
{
    [TestFixture]
    public class ProgramTest
    {
        /// <summary>
        /// clear all previously generated folders and files.
        /// </summary>
        [TestFixtureSetUp]
        public void clear_folders_and_files()
        {
            if (File.Exists("infile_PostProcessor_ROfRho.xml"))
            {
                File.Delete("infile_PostProcessor_ROfRho.xml");
            }
            if (File.Exists("infile_PostProcessor_pMC_ROfRhoROfRhoAndTime.xml"))
            {
                File.Delete("infile_PostProcessor_pMC_ROfRhoROfRhoAndTime.xml");
            }
            if (Directory.Exists("PostProcessor_ROfRhoROfRho"))
            {
                Directory.Delete("PostProcessor_ROfRho", true);
            }
            if (Directory.Exists("PostProcessor_pMC_ROfRhoROfRhoAndTime"))
            {
                Directory.Delete("PostProcessor_pMC_ROfRhoROfRhoAndTime", true); // delete recursively
            }
        }
        /// <summary>
        /// test to verify "geninfile" option works successfully
        /// </summary>
        [Test]
        public void validate_generate_infiles()
        {
            string[] arguments = new string[] {"geninfiles"};
            Program.Main(arguments);
            Assert.IsTrue(File.Exists("infile_PostProcessor_ROfRho.xml"));
            Assert.IsTrue(File.Exists("infile_PostProcessor_pMC_ROfRhoROfRhoAndTime.xml"));
        }        
        ///// <summary>
        ///// test to verify post-processor runs successfully.  NEED to determine way to
        ///// have databases generated by MCCL available to this test.
        ///// </summary>
        //[Test]
        //public void validate_post_processor_execution()
        //{
        //    var diffuseReflectanceDB = (PhotonDatabase)PhotonDatabase.FromFileInResources(
        //        "Vts.MonteCarlo.PostProcessor.Test/Resources/DiffuseReflectanceDatabase", "Vts.MonteCarlo.PostProcessor.Test");
        //    string[] arguments = new string[] { "infile=infile_PostProcessor_ROfRho.xml" };
        //    Program.Main(arguments);
        //    Assert.IsTrue(File.Exists("infile_PostProcessor_ROfRho.xml"));
        //}
    }
}
